Ext.define('DSS.addon.SingularZoneEditor', {
	extend : 'Ext.window.Window',
	editControls : {},
	buttonSave : null,
	buttonCancel : null,
	value : null,
	cboStore : null,
	lbFromValue : null,
	lbToValue : null,
	evalValue : function() {
		var fWeekend = false;
		var fWeekday = false;

		if (this.editControls['fromSunday'].getValue() != null)
			if (this.editControls['toSunday'].getValue() != null)
				if (this.editControls['fromSaturday'].getValue() != null)
					if (this.editControls['toSaturday'].getValue() != null) {
						var fromValue = this.editControls['fromSunday'].getValue();
						var toValue = this.editControls['toSunday'].getValue();
						if (fromValue == this.editControls['fromSaturday'].getValue())
							if (toValue == this.editControls['toSaturday'].getValue())
								fWeekend = true;
					}
		var oArray = [ 'Monday', 'Tuesday', 'Wednesday', 'Thirsday', 'Friday', 'Saturday', 'Sunday' ];
		var fCheckWeekday = true;
		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
			if (this.editControls['from' + oArray[iIndex]].getValue() == null)
				fCheckWeekday = false;
			if (this.editControls['to' + oArray[iIndex]].getValue() == null)
				fCheckWeekday = false;
		}
		if (fCheckWeekday) {
			fWeekday = true;
			var referenceFrom = this.editControls['from' + oArray[0]].getValue();
			var referenceTo = this.editControls['to' + oArray[0]].getValue();
			var oArray = [ 'Monday', 'Tuesday', 'Wednesday', 'Thirsday', 'Friday' ];
			for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
				if (referenceFrom != this.editControls['from' + oArray[iIndex]].getValue())
					fWeekday = false;
				if (referenceTo != this.editControls['to' + oArray[iIndex]].getValue())
					fWeekday = false;
			}
		}

		if (fWeekday && fWeekend) {
			if ((this.editControls['fromSunday'].getValue() == this.editControls['fromMonday'].getValue()) && (this.editControls['toSunday'].getValue() == this.editControls['toMonday'].getValue())) {
				this.editControls['fromWeekly'].suspendEvents();
				this.editControls['toWeekly'].suspendEvents();
				this.editControls['fromWeekly'].setValue(this.editControls['fromSunday'].getValue());
				this.editControls['toWeekly'].setValue(this.editControls['toSunday'].getValue());
				this.editControls['fromWeekly'].resumeEvents();
				this.editControls['toWeekly'].resumeEvents();
				this.editControls['rbWeekly'].setValue(true);
				this.tabPanel.setActiveTab(0);
				this.setDisabled('daily');
			} else {
				this.editControls['rbWeekday'].setValue(true);

				this.editControls['fromWeekly'].suspendEvents();
				this.editControls['toWeekly'].suspendEvents();
				this.editControls['fromWeekday'].suspendEvents();
				this.editControls['toWeekday'].suspendEvents();
				this.editControls['fromWeekend'].suspendEvents();
				this.editControls['toWeekend'].suspendEvents();
				this.editControls['fromWeekly'].setValue(null);
				this.editControls['toWeekly'].setValue(null);
				this.editControls['fromWeekday'].setValue(this.editControls['fromMonday'].getValue());
				this.editControls['toWeekday'].setValue(this.editControls['toMonday'].getValue());
				this.editControls['fromWeekend'].setValue(this.editControls['fromSunday'].getValue());
				this.editControls['toWeekend'].setValue(this.editControls['toSunday'].getValue());
				this.editControls['fromWeekly'].resumeEvents();
				this.editControls['toWeekly'].resumeEvents();
				this.editControls['fromWeekday'].resumeEvents();
				this.editControls['toWeekday'].resumeEvents();
				this.editControls['fromWeekend'].resumeEvents();
				this.editControls['toWeekend'].resumeEvents();
				this.editControls['rbWeekday'].setValue(true);
				this.tabPanel.setActiveTab(0);
				this.setDisabled('weekday');
			}
		} else {
			this.editControls['rbIndividual'].setValue(true);
			this.tabPanel.setActiveTab(1);
			this.setDisabled('individual');
		}
	},
	setValue : function(iZone) {
		if (iZone==null)
			this.cboBox.setValue(null);
		else
			this.cboBox.setValue(""+iZone);
	},
	setComboValue:function() {
		var zoneID=this.cboBox.getValue();
		if ((zoneID==null) || (this.base.notUsedWeek[zoneID]==null)) {
			this.editControls['toWeekly'].setValue(null);
			this.editControls['fromWeekly'].setValue(null);
			this.setValueDaily();
			this.evalValue();
			return;
		}
		var oValue=this.base.notUsedWeek[zoneID];
		
		
		this.value = oValue;
		var oArray = [ 'Weekly', 'Weekday', 'Weekend', 'Monday', 'Tuesday', 'Wednesday', 'Thirsday', 'Friday', 'Saturday', 'Sunday' ];

		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
			//this.editControls['from' + oArray[iIndex]].suspendEvents();
			//this.editControls['to' + oArray[iIndex]].suspendEvents();
		}

		if (oValue.MO != null) {
			this.editControls['fromMonday'].setValue(oValue.MO.from);
			this.editControls['toMonday'].setValue(oValue.MO.to);
		} else {
			this.editControls['fromMonday'].setValue(null);
			this.editControls['toMonday'].setValue(null);
		}
		if (oValue.TU != null) {
			this.editControls['fromTuesday'].setValue(oValue.TU.from);
			this.editControls['toTuesday'].setValue(oValue.TU.to);
		} else {
			this.editControls['fromTuesday'].setValue(null);
			this.editControls['toTuesday'].setValue(null);
		}
		if (oValue.WE != null) {
			this.editControls['fromWednesday'].setValue(oValue.WE.from);
			this.editControls['toWednesday'].setValue(oValue.WE.to);
		} else {
			this.editControls['fromWednesday'].setValue(null);
			this.editControls['toWednesday'].setValue(null);
		}
		if (oValue.TH != null) {
			this.editControls['fromThirsday'].setValue(oValue.TH.from);
			this.editControls['toThirsday'].setValue(oValue.TH.to);
		} else {
			this.editControls['fromThirsday'].setValue(null);
			this.editControls['toThirsday'].setValue(null);
		}
		if (oValue.FR != null) {
			this.editControls['fromFriday'].setValue(oValue.FR.from);
			this.editControls['toFriday'].setValue(oValue.FR.to);
		} else {
			this.editControls['fromFriday'].setValue(null);
			this.editControls['toFriday'].setValue(null);
		}
		if (oValue.SA != null) {
			this.editControls['fromSaturday'].setValue(oValue.SA.from);
			this.editControls['toSaturday'].setValue(oValue.SA.to);
		} else {
			this.editControls['fromSaturday'].setValue(null);
			this.editControls['toSaturday'].setValue(null);
		}
		if (oValue.SU != null) {
			this.editControls['fromSunday'].setValue(oValue.SU.from);
			this.editControls['toSunday'].setValue(oValue.SU.to);
		} else {
			this.editControls['fromSunday'].setValue(null);
			this.editControls['toSunday'].setValue(null);
		}
		this.evalValue();

		var oArray = [ 'Weekly', 'Weekday', 'Weekend', 'Monday', 'Tuesday', 'Wednesday', 'Thirsday', 'Friday', 'Saturday', 'Sunday' ];

		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
			//this.editControls['from' + oArray[iIndex]].resumeEvents();
			//this.editControls['to' + oArray[iIndex]].resumeEvents();
		}

	},
	getValue : function() {
		var value = {};
		value.zoneID=this.cboBox.getValue();
		if (this.editControls['fromMonday'].getValue() != null) 
			if (this.editControls['toMonday'].getValue() != null) {
				value.MO = {
					from : this.editControls['fromMonday'].getValue(),
					to : this.editControls['toMonday'].getValue(),
					fromID : null,
					toID : null
				};
				if (this.value != null)
					if (this.value.MO != null) {
						if (this.value.MO.fromID != null)
							value.MO.fromID = this.value.MO.fromID;
						if (this.value.MO.toID != null)
							value.MO.toID = this.value.MO.toID;
					}
			}
		
		if (this.editControls['fromTuesday'].getValue() != null)
			if (this.editControls['toTuesday'].getValue() != null) {
				value.TU = {
					from : this.editControls['fromTuesday'].getValue(),
					to : this.editControls['toTuesday'].getValue(),
					fromID : null,
					toID : null
				};
				if (this.value != null)
					if (this.value.TU != null) {
						if (this.value.TU.fromID != null)
							value.TU.fromID = this.value.TU.fromID;
						if (this.value.TU.toID != null)
							value.TU.toID = this.value.TU.toID;
					}
			}
		if (this.editControls['fromWednesday'].getValue() != null)
			if (this.editControls['toWednesday'].getValue() != null) {
				value.WE = {
					from : this.editControls['fromWednesday'].getValue(),
					to : this.editControls['toWednesday'].getValue(),
					fromID : null,
					toID : null
				};
				if (this.value != null)
					if (this.value.WE != null) {
						if (this.value.WE.fromID != null)
							value.WE.fromID = this.value.WE.fromID;
						if (this.value.WE.toID != null)
							value.WE.toID = this.value.WE.toID;
					}
			}
		if (this.editControls['fromThirsday'].getValue() != null)
			if (this.editControls['toThirsday'].getValue() != null) {
				value.TH = {
					from : this.editControls['fromThirsday'].getValue(),
					to : this.editControls['toThirsday'].getValue(),
					fromID : null,
					toID : null
				};
				if (this.value != null)
					if (this.value.TH != null) {
						if (this.value.TH.fromID != null)
							value.TH.fromID = this.value.TH.fromID;
						if (this.value.TH.toID != null)
							value.TH.toID = this.value.TH.toID;
					}
			}
		if (this.editControls['fromFriday'].getValue() != null)
			if (this.editControls['toFriday'].getValue() != null) {
				value.FR = {
					from : this.editControls['fromFriday'].getValue(),
					to : this.editControls['toFriday'].getValue(),
					fromID : null,
					toID : null
				};
				if (this.value != null)
					if (this.value.FR != null) {
						if (this.value.FR.fromID != null)
							value.FR.fromID = this.value.FR.fromID;
						if (this.value.FR.toID != null)
							value.FR.toID = this.value.FR.toID;
					}
			}
		if (this.editControls['fromSaturday'].getValue() != null)
			if (this.editControls['toSaturday'].getValue() != null) {
				value.SA = {
					from : this.editControls['fromSaturday'].getValue(),
					to : this.editControls['toSaturday'].getValue(),
					fromID : null,
					toID : null
				};
				if (this.value != null)
					if (this.value.SA != null) {
						if (this.value.SA.fromID != null)
							value.SA.fromID = this.value.SA.fromID;
						if (this.value.SA.toID != null)
							value.SA.toID = this.value.SA.toID;
					}
			}
		if (this.editControls['fromSunday'].getValue() != null)
			if (this.editControls['toSunday'].getValue() != null) {
				value.SU = {
					from : this.editControls['fromSunday'].getValue(),
					to : this.editControls['toSunday'].getValue(),
					fromID : null,
					toID : null
				};
				if (this.value != null)
					if (this.value.SU != null) {
						if (this.value.SU.fromID != null)
							value.SU.fromID = this.value.SU.fromID;
						if (this.value.SU.toID != null)
							value.SU.toID = this.value.SU.toID;
					}
			}
		return value;
	},
	setValueDaily : function() {

		var fromValue = this.editControls['fromWeekly'].getValue();
		var toValue = this.editControls['toWeekly'].getValue();

		var oArray = [ 'Weekday', 'Weekend' ];
		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
			this.editControls['from' + oArray[iIndex]].suspendEvents();
			this.editControls['to' + oArray[iIndex]].suspendEvents();
			this.editControls['from' + oArray[iIndex]].setValue(fromValue);
			this.editControls['to' + oArray[iIndex]].setValue(toValue);
			this.editControls['from' + oArray[iIndex]].resumeEvents();
			this.editControls['to' + oArray[iIndex]].resumeEvents();
		}
		var oArray = [  'Monday', 'Tuesday', 'Wednesday', 'Thirsday', 'Friday', 'Saturday', 'Sunday' ];
		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
			//this.editControls['from' + oArray[iIndex]].suspendEvents();
			//this.editControls['to' + oArray[iIndex]].suspendEvents();
			this.editControls['from' + oArray[iIndex]].setValue(fromValue);
			this.editControls['to' + oArray[iIndex]].setValue(toValue);
			//this.editControls['from' + oArray[iIndex]].resumeEvents();
			//this.editControls['to' + oArray[iIndex]].resumeEvents();
		}
	},
	setWeekdayValue : function() {
		var oArray = [ 'Saturday', 'Sunday' ];

		var fromValue = this.editControls['fromWeekend'].getValue();
		var toValue = this.editControls['toWeekend'].getValue();

		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
			//this.editControls['from' + oArray[iIndex]].suspendEvents();
			//this.editControls['to' + oArray[iIndex]].suspendEvents();
			this.editControls['from' + oArray[iIndex]].setValue(fromValue);
			this.editControls['to' + oArray[iIndex]].setValue(toValue);
			//this.editControls['from' + oArray[iIndex]].resumeEvents();
			//this.editControls['to' + oArray[iIndex]].resumeEvents();
		}
		oArray = [ 'Monday', 'Tuesday', 'Wednesday', 'Thirsday', 'Friday' ];

		fromValue = this.editControls['fromWeekday'].getValue();
		toValue = this.editControls['toWeekday'].getValue();

		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
			//this.editControls['from' + oArray[iIndex]].suspendEvents();
			//this.editControls['to' + oArray[iIndex]].suspendEvents();
			this.editControls['from' + oArray[iIndex]].setValue(fromValue);
			this.editControls['to' + oArray[iIndex]].setValue(toValue);
			//this.editControls['from' + oArray[iIndex]].resumeEvents();
			//this.editControls['to' + oArray[iIndex]].resumeEvents();
		}
	},
	setDisabled : function(value) {
		this.editControls['fromMonday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['toMonday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['fromTuesday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['toTuesday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['fromWednesday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['toWednesday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['fromThirsday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['toThirsday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['fromFriday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['toFriday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['fromSaturday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['toSaturday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['fromSunday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['toSunday'].numMinutes.setDisabled(!(value == 'individual'));
		this.editControls['fromMonday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['toMonday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['fromTuesday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['toTuesday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['fromWednesday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['toWednesday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['fromThirsday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['toThirsday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['fromFriday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['toFriday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['fromSaturday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['toSaturday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['fromSunday'].numHour.setDisabled(!(value == 'individual'));
		this.editControls['toSunday'].numHour.setDisabled(!(value == 'individual'));

		this.editControls['fromWeekly'].numMinutes.setDisabled(!(value == 'daily'));
		this.editControls['toWeekly'].numMinutes.setDisabled(!(value == 'daily'));
		this.editControls['fromWeekly'].numHour.setDisabled(!(value == 'daily'));
		this.editControls['toWeekly'].numHour.setDisabled(!(value == 'daily'));

		this.editControls['fromWeekday'].numMinutes.setDisabled(!(value == 'weekday'));
		this.editControls['toWeekday'].numMinutes.setDisabled(!(value == 'weekday'));
		this.editControls['fromWeekend'].numMinutes.setDisabled(!(value == 'weekday'));
		this.editControls['toWeekend'].numMinutes.setDisabled(!(value == 'weekday'));
		this.editControls['fromWeekday'].numHour.setDisabled(!(value == 'weekday'));
		this.editControls['toWeekday'].numHour.setDisabled(!(value == 'weekday'));
		this.editControls['fromWeekend'].numHour.setDisabled(!(value == 'weekday'));
		this.editControls['toWeekend'].numHour.setDisabled(!(value == 'weekday'));
	},
	makeIndividualPanel : function() {
		var me = this;
		this.editControls['rbIndividual'] = Ext.create('Ext.form.field.Radio', {
			boxLabel : '<span style="color:#005138">' + _('individual selections:') + "</span>",
			name : 'recurrence',
			inputValue : 'individual',
			listeners : {
				'change' : function(mThis, newValue) {
					if (newValue)
						me.setDisabled('individual');
				}
			}
		});

		this.editControls['fromMonday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			margin : '0 0 0 20',
			fieldLabel : _('Monday from'),
			withEnabler:true,
			listeners : {
				'enabledChange' : function() {
					me.editControls['toMonday'].numHour.setDisabled(false);
					me.editControls['toMonday'].numMinutes.setDisabled(false);
				},
				'disabledChange' : function() {
					me.editControls['toMonday'].numHour.setDisabled(true);
					me.editControls['toMonday'].numMinutes.setDisabled(true);
				},
				'change' : function(mThis, newValue) {
					me.editControls['toMonday'].setMinValue(me.editControls['fromMonday'].getValue());					
				}
			}
		});
		this.editControls['fromMonday'].numMinutes.step = 5;
		this.editControls['fromMonday'].lblHMS.setVisible(false);
		this.editControls['toMonday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until')
		});
		this.editControls['toMonday'].numMinutes.step = 5;

		this.editControls['fromTuesday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			margin : '0 0 0 20',
			withEnabler:true,
			fieldLabel : _('Tuesday from'),
			listeners : {
				'enabledChange' : function() {
					me.editControls['toTuesday'].numHour.setDisabled(false);
					me.editControls['toTuesday'].numMinutes.setDisabled(false);
				},
				'disabledChange' : function() {
					me.editControls['toTuesday'].numHour.setDisabled(true);
					me.editControls['toTuesday'].numMinutes.setDisabled(true);
				},
				'change' : function(mThis, newValue) {
					me.editControls['toTuesday'].setMinValue(me.editControls['fromTuesday'].getValue());					
				}
			}
		});
		this.editControls['fromTuesday'].numMinutes.step = 5;
		this.editControls['fromTuesday'].lblHMS.setVisible(false);
		this.editControls['toTuesday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until')
		});
		this.editControls['toTuesday'].numMinutes.step = 5;

		this.editControls['fromWednesday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			withEnabler:true,
			margin : '0 0 0 20',
			fieldLabel : _('Wednesday from'),
			listeners : {
				'enabledChange' : function() {
					me.editControls['toWednesday'].numHour.setDisabled(false);
					me.editControls['toWednesday'].numMinutes.setDisabled(false);
				},
				'disabledChange' : function() {
					me.editControls['toWednesday'].numHour.setDisabled(true);
					me.editControls['toWednesday'].numMinutes.setDisabled(true);
				},
				'change' : function(mThis, newValue) {
					me.editControls['toWednesday'].setMinValue(me.editControls['fromWednesday'].getValue());					
				}
			}
		});
		this.editControls['fromWednesday'].numMinutes.step = 5;
		this.editControls['fromWednesday'].lblHMS.setVisible(false);
		this.editControls['toWednesday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until')
		});
		this.editControls['toWednesday'].numMinutes.step = 5;

		this.editControls['fromThirsday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			withEnabler:true,
			margin : '0 0 0 20',
			fieldLabel : _('Thirsday from'),
			listeners : {
				'enabledChange' : function() {
					me.editControls['toThirsday'].numHour.setDisabled(false);
					me.editControls['toThirsday'].numMinutes.setDisabled(false);
				},
				'disabledChange' : function() {
					me.editControls['toThirsday'].numHour.setDisabled(true);
					me.editControls['toThirsday'].numMinutes.setDisabled(true);
				},
				'change' : function(mThis, newValue) {
					me.editControls['toThirsday'].setMinValue(me.editControls['fromThirsday'].getValue());					
				}
			}
		});
		this.editControls['fromThirsday'].numMinutes.step = 5;
		this.editControls['fromThirsday'].lblHMS.setVisible(false);
		this.editControls['toThirsday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until')
		});
		this.editControls['toThirsday'].numMinutes.step = 5;

		this.editControls['fromFriday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			withEnabler:true,
			margin : '0 0 0 20',
			fieldLabel : _('Friday from'),
			listeners : {
				'enabledChange' : function() {
					me.editControls['toFriday'].numHour.setDisabled(false);
					me.editControls['toFriday'].numMinutes.setDisabled(false);
				},
				'disabledChange' : function() {
					me.editControls['toFriday'].numHour.setDisabled(true);
					me.editControls['toFriday'].numMinutes.setDisabled(true);
				},
				'change' : function(mThis, newValue) {
					me.editControls['toFriday'].setMinValue(me.editControls['fromFriday'].getValue());					
				}
			}
		});
		this.editControls['fromFriday'].numMinutes.step = 5;
		this.editControls['fromFriday'].lblHMS.setVisible(false);
		this.editControls['toFriday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until')
		});
		this.editControls['toFriday'].numMinutes.step = 5;

		this.editControls['fromSaturday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			withEnabler:true,
			margin : '0 0 0 20',
			fieldLabel : _('Saturday from'),
			listeners : {
				'enabledChange' : function() {
					me.editControls['toSaturday'].numHour.setDisabled(false);
					me.editControls['toSaturday'].numMinutes.setDisabled(false);
				},
				'disabledChange' : function() {
					me.editControls['toSaturday'].numHour.setDisabled(true);
					me.editControls['toSaturday'].numMinutes.setDisabled(true);
				},
				'change' : function(mThis, newValue) {
					me.editControls['toSaturday'].setMinValue(me.editControls['fromSaturday'].getValue());					
				}
			}
		});
		this.editControls['fromSaturday'].numMinutes.step = 5;
		this.editControls['fromSaturday'].lblHMS.setVisible(false);
		this.editControls['toSaturday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until')
		});
		this.editControls['toSaturday'].numMinutes.step = 5;

		this.editControls['fromSunday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			withEnabler:true,
			margin : '0 0 0 20',
			fieldLabel : _('Sunday from'),
			listeners : {
				'enabledChange' : function() {
					me.editControls['toSunday'].numHour.setDisabled(false);
					me.editControls['toSunday'].numMinutes.setDisabled(false);
				},
				'disabledChange' : function() {
					me.editControls['toSunday'].numHour.setDisabled(true);
					me.editControls['toSunday'].numMinutes.setDisabled(true);
				},
				'change' : function(mThis, newValue) {
					me.editControls['toSunday'].setMinValue(me.editControls['fromSunday'].getValue());					
				}
			}
		});
		this.editControls['fromSunday'].numMinutes.step = 5;
		this.editControls['fromSunday'].lblHMS.setVisible(false);
		this.editControls['toSunday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until')
		});
		this.editControls['toSunday'].numMinutes.step = 5;

		return Ext.create('Ext.panel.Panel', {
			border : false,
			layout : 'vbox',
			items : [ this.editControls['rbIndividual'], {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				margin:'0 0 3 0',
				items : [ this.editControls['fromMonday'], this.editControls['toMonday'] ]
			}, {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				margin:'0 0 3 0',
				items : [ this.editControls['fromTuesday'], this.editControls['toTuesday'] ]
			}, {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				margin:'0 0 3 0',
				items : [ this.editControls['fromWednesday'], this.editControls['toWednesday'] ]
			}, {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				margin:'0 0 3 0',
				items : [ this.editControls['fromThirsday'], this.editControls['toThirsday'] ]
			}, {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				margin:'0 0 3 0',
				items : [ this.editControls['fromFriday'], this.editControls['toFriday'] ]
			}, {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				margin:'0 0 3 0',
				items : [ this.editControls['fromSaturday'], this.editControls['toSaturday'] ]
			}, {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				items : [ this.editControls['fromSunday'], this.editControls['toSunday'] ]
			} ]
		});
	},
	makeGeneralPanel : function() {
		var me = this;
		this.editControls['rbWeekly'] = Ext.create('Ext.form.field.Radio', {
			boxLabel : '<span style="color:#005138">' + _('daily the same on') + '</span>',
			name : 'recurrence',
			inputValue : 'daily',
			listeners : {
				'change' : function(mThis, newValue) {
					if (newValue)
						me.setDisabled('daily');
				}
			}
		});
		this.editControls['fromWeekly'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			margin : '0 0 0 20',
			fieldLabel : _('daily from'),
			listeners : {
				'change' : function(mThis, newValue) {
					me.editControls['toWeekly'].setMinValue(me.editControls['fromWeekly'].getValue());
					me.setValueDaily();
					
				}
			}
		});
		this.editControls['fromWeekly'].numMinutes.step = 5;
		this.editControls['fromWeekly'].lblHMS.setVisible(false);
		this.editControls['toWeekly'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until'),
			listeners : {
				'change' : function(mThis, newValue) {
					me.setValueDaily();
				}
			}
		});
		this.editControls['toWeekly'].numMinutes.step = 5;
		this.editControls['rbWeekday'] = Ext.create('Ext.form.field.Radio', {
			boxLabel : '<span style="color:#005138">' + _('weekday / weekends') + '</span>',
			name : 'recurrence',
			inputValue : 'weekday',
			listeners : {
				'change' : function(mThis, newValue) {
					if (newValue)
						me.setDisabled('weekday');
				}
			}
		});
		this.editControls['fromWeekday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			margin : '0 0 0 20',
			fieldLabel : _('Weekday from'),
			listeners : {
				'change' : function(mThis, newValue) {
					me.editControls['toWeekday'].setMinValue(me.editControls['fromWeekday'].getValue());
					me.setWeekdayValue();
				}
			}
		});
		this.editControls['fromWeekday'].numMinutes.step = 5;
		this.editControls['fromWeekday'].lblHMS.setVisible(false);
		this.editControls['toWeekday'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until'),
			listeners : {
				'change' : function(mThis, newValue) {
					me.setWeekdayValue();
				}
			}
		});
		this.editControls['toWeekday'].numMinutes.step = 5;
		this.editControls['fromWeekend'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 100,
			width : 250,
			hideSecond : true,
			margin : '0 0 0 20',
			fieldLabel : _('Weekend from'),
			listeners : {
				'change' : function(mThis, newValue) {
					me.editControls['toWeekend'].setMinValue(me.editControls['fromWeekend'].getValue());
					me.setWeekdayValue();
				}
			}
		});
		this.editControls['fromWeekend'].numMinutes.step = 5;
		this.editControls['fromWeekend'].lblHMS.setVisible(false);
		this.editControls['toWeekend'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 50,
			width : 200,
			hideSecond : true,
			fieldLabel : _('until'),
			listeners : {
				'change' : function(mThis, newValue) {
					me.setWeekdayValue();
				}
			}
		});
		this.editControls['toWeekend'].numMinutes.step = 5;
		return Ext.create('Ext.panel.Panel', {
			border : false,
			layout : 'vbox',
			items : [ this.editControls['rbWeekly'], {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				items : [ this.editControls['fromWeekly'], this.editControls['toWeekly'] ]
			}, this.editControls['rbWeekday'], {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				items : [ this.editControls['fromWeekday'], this.editControls['toWeekday'] ]
			}, {
				xtype : 'panel',
				border : false,
				layout : 'hbox',
				items : [ this.editControls['fromWeekend'], this.editControls['toWeekend'] ]
			} ]
		});
	},
	constructor : function(config) {
		var me = this;
		this.value = {};
		config.closeAction = 'hide';
		config.modal = true;
		config.height = 360;
		config.width = 500;
		config.layout = 'fit';
		config.appName = '';
		config.resizable = false;
		config.title = _('Configure zone usage settings');

		me.buttonSave = Ext.create('Ext.Button', {
			text : _('save'),
			handler : function() {
				me.base.saveSingularyTime(me.getValue());
				me.hide();
			}
		});
		me.buttonCancel = Ext.create('Ext.Button', {
			text : _('cancel'),
			handler : function() {
				me.hide();
			}
		});
		this.displayBottomText = Ext.create('Ext.form.field.Display', {
			border : 0,
			value : '',
			style : {
				fontSize : '11px'
			},
			padding : '0 0 2 5',
			flex : 1
		});
		var oButtons = [ this.displayBottomText ];

		oButtons.push(me.buttonSave);
		oButtons.push(me.buttonCancel);

		this.cboBox = Ext.create('Ext.form.field.ComboBox', {
			editable : false,
			store : Ext.data.StoreManager.lookup('usableZones'),
			queryMode : 'local',
			displayField : 'name',
			valueField : 'id',
			fieldLabel : _('zone'),
			labelWidth :130,
			width : 470,
			margin : "10 0 10 10",
			listeners: {
				change: function() {me.setComboValue();}
			}
		});

		var generalPanel = this.makeGeneralPanel();
		var individualPanel = this.makeIndividualPanel();
		this.tabPanel = Ext.create('Ext.tab.Panel', {
			xtype : 'tabpanel',
			items : [ {
				title : _('general'),
				xtype : 'panel',
				border : false,
				items : [ generalPanel ]
			}, {
				title : _('individual'),
				xtype : 'panel',
				border : false,
				items : [ individualPanel ]
			} ],
			bodyPadding : 5,
			border : 0

		});
		Ext.apply(me, {
			items : [ {
				xtype : 'panel',
				border : false,
				layout : 'vbox',
				items : [ this.cboBox, this.tabPanel ],
				dockedItems : [ {
					xtype : 'toolbar',
					dock : 'bottom',
					ui : 'footer',
					defaults : {
						minWidth : 75
					},
					items : oButtons
				} ]
			} ]
		}); // Ext.apply
		this.callParent(arguments);
	}
});
